#include <iostream>
#include <stdlib.h>
#include <stdio.h>
#include <memory>

class RAII_file {
    public:
        FILE* fh;
        RAII_file( const char* filename ) : fh(NULL) {
            if ( filename ) { fh = fopen( filename, "w" ); }
        }
        ~RAII_file() {
            if ( fh ) { fclose( fh ); }
         }
};

void do_file_on_stack() {
    RAII_file F( "foo1.txt" );
    fprintf( F.fh, "hello world 1\n" );
}

std::shared_ptr<RAII_file> build_file_on_heap( const char* filename ) {
    std::shared_ptr<RAII_file> rtval = std::make_shared<RAII_file> ( filename ) ;
    return rtval;
}

int main() {

    do_file_on_stack();
    std::shared_ptr<RAII_file> sp = build_file_on_heap( "foo2.txt" );
    fprintf( sp->fh, "hello world 2\n" );

}

