
package require itcl

proc try_it {} {
  set foo [collection::create "Harry"]
  set bar [collection::create "Sue"]

  # do some stuff with $foo and $bar - the same as if they were Tcl_Obj's 

  $foo do_something

  # the commands stored in foo and bar will be destroyed on exit from
  # the proc
}


# you'd accomplish this via an Itcl class

itcl::class collection {
  public proc create {data} {
    uplevel 1 [list itcl::local collection #auto $data]
  }
  private constructor {data} {
    set m_data $data
  }
  destructor {
    puts "Collection containing $m_data is going bye-bye"
  }
  public method do_something {args} {
    puts "We would do something with $args in collection $m_data "
  }
  private variable m_data
}

try_it
